Bug 7494 - Use partial barcode or callnumber as a fallback for the barcode search in checkout
Summary: Use partial barcode or callnumber as a fallback for the barcode search in che...
Status: CLOSED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Circulation (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: MJ Ray (software.coop)
QA Contact: Jonathan Druart
URL: http://koha:8080/cgi-bin/koha/circ/ci...
Keywords:
Depends on:
Blocks: 10768 12256
  Show dependency treegraph
 
Reported: 2012-02-02 19:19 UTC by MJ Ray (software.coop)
Modified: 2018-02-19 11:38 UTC (History)
6 users (show)

See Also:
Change sponsored?: Seeking cosponsors
Patch complexity: Small patch
Who signed the patch off:
Text to go in the release notes:
Version(s) released in:


Attachments
bug 7494: optional checkout-time fallback search for a book (7.09 KB, patch)
2012-03-27 16:55 UTC, MJ Ray (software.coop)
Details | Diff | Splinter Review
bug 7494: optional checkout-time fallback search for a book (7.12 KB, patch)
2012-06-10 16:03 UTC, MJ Ray (software.coop)
Details | Diff | Splinter Review
bug 7494: optional checkout-time fallback search for a book (8.19 KB, patch)
2013-03-07 17:10 UTC, MJ Ray (software.coop)
Details | Diff | Splinter Review
bug 7494: optional checkout-time fallback search for a book (7.93 KB, patch)
2013-03-19 10:54 UTC, MJ Ray (software.coop)
Details | Diff | Splinter Review
bug 7494: optional checkout-time fallback search for a book (7.93 KB, patch)
2013-03-21 17:34 UTC, MJ Ray (software.coop)
Details | Diff | Splinter Review
bug 7494: optional checkout-time fallback search for a book (8.24 KB, patch)
2013-04-12 13:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
bug 7494: optional checkout-time fallback search for a book (8.31 KB, patch)
2013-06-14 09:48 UTC, Jonathan Druart
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description MJ Ray (software.coop) 2012-02-02 19:19:33 UTC
This could be done in a similar manner to Bug 1081. Probably should be optional, as should that search.

An alternative implementation may be to add a Checkout button under "Available" entries in the "Status" column of the item table in the catalogue/detail.pl output.
Comment 1 MJ Ray (software.coop) 2012-03-27 16:55:56 UTC Comment hidden (obsolete)
Comment 2 MJ Ray (software.coop) 2012-06-10 16:03:31 UTC Comment hidden (obsolete)
Comment 3 MJ Ray (software.coop) 2012-06-10 16:04:43 UTC
rebased to current master.

The idea of this feature is that if nothing is found as a barcode, it will do a regular search and use that if there is a match, warning if there were multiple matches.
Comment 4 Marijana Glavica 2012-06-11 13:17:55 UTC
It works in the simplest case when you have just one item attached to your biblio. It offers you always just first item. If that first item is already on loan, it will not offer you next one available. Also, if you have more than one item, and first one is marked as "not for loan", it will tell you that item is not for loan (because it looks just at the fist item).

It offers you just first biblio if more than one result exist, but that is fine, you can search more precisely.

So, you can use this feature only if you always have just one item attached to every biblio.
Comment 5 MJ Ray (software.coop) 2013-03-07 17:10:05 UTC Comment hidden (obsolete)
Comment 6 MJ Ray (software.coop) 2013-03-07 17:12:04 UTC
rebased to current master

I think this version allows you to choose between possible matches.  Do you think this could be included?
Comment 7 MJ Ray (software.coop) 2013-03-19 10:54:10 UTC Comment hidden (obsolete)
Comment 8 MJ Ray (software.coop) 2013-03-19 10:54:50 UTC
trivial rebase to current master
Comment 9 Owen Leonard 2013-03-19 18:35:35 UTC
I think the warning next needs to be tweaked a little to make this readable. If I input a call number the dialog begins with this line:

The barcode was not found 636.1 En Fast cataloging 

Something more readable might be:

No barcode found matching "636.1 En" [Add record using fast cataloging]

I'm also concerned about the amount of information offered by the buttons. Will it be enough to identify the correct copy? I would think you should also include library, item type, and collection code information.

What about availability? Does it only offer to check out items which are available? If not, you would need to include availability/status information as well.

One more thing: We use "Check out" instead of "Issue."
Comment 10 MJ Ray (software.coop) 2013-03-20 11:42:39 UTC
(In reply to comment #9)
> I think the warning next needs to be tweaked a little to make this readable.
> If I input a call number the dialog begins with this line:
> 
> The barcode was not found 636.1 En Fast cataloging 
> 
> Something more readable might be:
> 
> No barcode found matching "636.1 En" [Add record using fast cataloging]
> 
> I'm also concerned about the amount of information offered by the buttons.
> Will it be enough to identify the correct copy? I would think you should
> also include library, item type, and collection code information.

I did not change that warning text and I do not intend to change it. Please open a new bug about that - and maybe the html syntax bug (early </li>) that I did change because I needed to to make the new form display correctly.

> What about availability? Does it only offer to check out items which are
> available? If not, you would need to include availability/status information
> as well.

I'll see what has to be added to a SimpleSearch to only offer available items, or how to show availability information.  Any ideas?

> One more thing: We use "Check out" instead of "Issue."

Good catch. I'll fix that one on next upload.
Comment 11 MJ Ray (software.coop) 2013-03-21 17:34:02 UTC Comment hidden (obsolete)
Comment 12 MJ Ray (software.coop) 2013-03-21 17:34:45 UTC
Corrected Issue to Check out.

[17:32]<jcamins> slef: it probably doesn't work in the staff client either.
       <jcamins> In fact, I'm sure it doesn't.
       <jcamins> Availability limits are fundamentally broken.
       <slef> ok, I'll leave it undone in the new feature
       <jcamins> Good plan.
Comment 13 Kyle M Hall 2013-04-12 13:37:19 UTC Comment hidden (obsolete)
Comment 14 Kyle M Hall 2013-04-12 13:39:19 UTC
Note: This may be a useful building block to get the barcode prefixes to pass QA ( i.e. display this if multiple items share a root barcode, in case a librarian is accidentally checking in an item from another library that uses the same barcode )
Comment 15 Jonathan Druart 2013-06-14 09:48:32 UTC
QA comment:

The introduced behavior seems logical.
All works as expected.
Minor: 
- the ergonomic should certainly improved later.
- there are some indentation issues, I will fix them with my patch.
- the variable name "options" is not well choosen.

Marked as Passed QA.
Comment 16 Jonathan Druart 2013-06-14 09:48:53 UTC
Created attachment 18981 [details] [review]
bug 7494: optional checkout-time fallback search for a book

When issuing a book, some libraries want to issue by title or other details.
This patch adds a systempreference and code that allows it.

To test:
1) scan a patron card or enter a surname to start checking out;
2) enter title or other keywords;
3) the circulation screen should display a warning allowing to choose between copies.

Signed-off-by: MJ Ray <mjr@phonecoop.coop>
Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Signed-off-by: Jonathan Druart <jonathan.druart@biblibre.com>
Comment 17 Galen Charlton 2013-07-24 15:14:35 UTC
Pushed to master.  Thanks, MJ!
Comment 18 Magnus Enger 2013-08-20 09:02:29 UTC
Searching Bugzilla for itemBarcodeFallbackSearch did not turn up this bug, but with this comment it will. :-)
Comment 19 Ravi Thakur 2018-02-19 11:31:38 UTC
Comment on attachment 18981 [details] [review]
bug 7494: optional checkout-time fallback search for a book

sir, can u tell me where to make these changes?
Comment 20 Magnus Enger 2018-02-19 11:38:55 UTC
(In reply to Ravi Thakur from comment #19)
> Comment on attachment 18981 [details] [review] [review]
> bug 7494: optional checkout-time fallback search for a book
> 
> sir, can u tell me where to make these changes?

This development was made a part of Koha in July 2013, so if you have a version of Koha that is more recent than that, yo ushould already have this functionality in place. Look for itemBarcodeFallbackSearch among the system preferences.